/*-----------------------------------------------------------------------

                         SYRTHES version 3.4
                         -------------------

     This file is part of the SYRTHES Kernel, element of the
     thermal code SYRTHES.

     Copyright (C) 1988-2008 EDF S.A., France

     contact: syrthes-support@edf.fr


     The SYRTHES Kernel is free software; you can redistribute it
     and/or modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2 of
     the License, or (at your option) any later version.

     The SYRTHES Kernel is distributed in the hope that it will be
     useful, but WITHOUT ANY WARRANTY; without even the implied warranty
     of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.


     You should have received a copy of the GNU General Public License
     along with the Code_Saturne Kernel; if not, write to the
     Free Software Foundation, Inc.,
     51 Franklin St, Fifth Floor,
     Boston, MA  02110-1301  USA

-----------------------------------------------------------------------*/
/*|======================================================================|
  | SYRTHES 3.4.2                                     COPYRIGHT EDF 2008 |
  |======================================================================| */
#include "f2c_syrthes.h"

    void alter_axi1      (int,int,double*,double*);	
    void affiche_tree    (struct node *,int);
    void axi_integ_fc    (double*,double*,double*);
    void axi_integ_vis   (double*,double*,double*);
    void bary3d          (double,double,double,double,double,double,double,double,double,
	                  double,double,double,double *,double *,double *);
    void boite           (int,int,double*,double*);
    void boite2          (int,int,double*,int,double*,double*);
    void box_2d          (int,double *);
    void box_3d          (int,double *);
    void build_octree    (struct node * ,int,int ,int ,int *,double *,double *,double *);
    void build_octree_1d (struct node * ,int,int ,int ,int *,double *,double *,double *);
    void build_quadtree_1d(struct node *, int,int ,int, int *,double *,double *,double *);

    void cal_dmin        (double,double,double, double *,double *,double *,double *,
                          double *,double *, double *,double *,double *,
	                  int,double *,double *,double *, double *,int *,int *,int *);

    void cnor_2d         (int,int,int,int *,double *,double *);
    void cnor_3d         (int,int,int,int *,double *,double *);
    void connex_2d       (int*, int*, int, int, int*, int, int) ;
    void connex_3d       (int*, int*, int, int, int*, int, int) ;
    double coplanaire_2a (int,double,double,double,double);
    double coplanaire_2d (double,double,double,double);
    double coplanaire_3d (double,double,double,double,double,double);
    void couple_mst_2d   (int,int*,int,int,int*,double*,double*,int);
    void couple_mst_3d   (int,int*,int,int,int*,double*,double*,int);
    int  diag_tria       (double,double,double,double,double,double,double,double*);
    void decoupe         (struct node *,int *,double *,int,int,int,double*);
    void decoupe1d       (struct node *,int *,double *,int,int,int,double*);
    void decoupe_seg     (int,int,int,double *,double *,double *,double *,double *,int);
    void decoupe_totd    (int,int,int,double *,double *,double *,double *,double *,double *,int);
    void decoupe_toqd    (int,int,int,double *,double *,double *,double *,double *,
		          double *,double *,double *,double *,int);
    void decoupe_tdtd    (int,int,int,double *,double *,double *,double *,double *,
		          double *,int);
    void decoupe_qdqd    (int,int,int,double *,double *,double *,double *,double *,
		          double *,double *,double *,double *,double *,double *,
		          double *,int);
    void decoupe_tdqd    (int,int,int,double *,double *,double *,double *,double *,
		          double *,double *,double *,double *,double *,double *,double *,int);
    void decouphor_2a    (int,double * , double *, double, double, double ,double);
    void derriere_2a     (int,int,int,double,double,double,double,double,double,double,double,int*);
    void derriere_2d     (int,int,int,double*,double*,double*,double*,double*,int*);
    void derriere_3d     (int,int,int,double*,double*,double*,double*,double*,double*,int*);
    double determ        (double,double,double, double,double,double,double,double,double);
    void dimension_3d    (int,int,int,int *,double *,double *,double *);
    void dimension_2d    (int,int,int,int *,double *,double *,double *);
    void dupliq2d_per    (int,double*,int,double*,
		          int,int,int*,double*,double*,int*,int*,int*,double*,double*,int*,int*);
    void dupliq3d_per    (int,double*,int,double*,
		          int,int,int*,double*,double*,int*,int*,int*,double*,double*,int*,int*);
    void dupliq2d_sym    (int,double*,
		          int,int,int*,double*,double*,int*,int*,int*,double*,double*,int*,int*);
    void dupliq3d_sym     (int,double*,
		          int,int,int*,double*,double*,int*,int*,int*,double*,double*,int*,int*);
    void elague_tree     (struct node *,struct node *,int);
    void facforme_2a_fc  (int,int,int,int,int*,double*,double*,double*,double*,int,int,int,int*,int);
    void facforme_2a_vis (int,int,int,int,int*,double*,double*,double*,double*,int,int,int,int*,int);
    void facforme_2d     (int,int,int,int,int*,double*,double*,double*,double*,int*,int,int,int,int*,int);
    void facforme_3d     (int,int,int,int,int*,double*,double*,double*,double*,int*,int,int,int,int*,int);
    void facecache_2d    (int,int,int,int,int*,double*,double*,    int*    ,int,int);
    void facecache_2a    (int,int,int,int,int*,double*,double*,    int*    ,int);
    void facecache_3d    (int,int,int,int,int*,double*,double*,    int*    ,int,int);
    void find_node_2d    (struct node **, double , double);
    void find_node_3d    (struct node **, double , double , double);
    void gauss           (void);
    void group_2d        (int,int,int,int*,int*,int);
    void group_3d        (int,int,int,int*,int*,int);
    int  indvoir         (int,int,int);
    void iniori_2d       (int*, int*, double*, int*, int*, int, int ,
                          double*, int*, int, int*, int*, int , int*, int) ;
    void iniori_3d       (int*, int*, double*, int*, int*, int, int ,
                          double*, int*, int, int*, int*, int , int*, int) ;
    int  in_boite        (double,double,double,
                          double,double,double,double,double,double);
    int  in_triangle     (double , double , double , double ,
		          double ,double ,double ,double ,double ,double ,
 		          double ,double ,double ,
		          double ,double ,double);
    int in_rectan        (double,double,double,double,double,double);
    int in_seg           (double, double, double, double,double, double);
    void ivoitj_2d       (struct node *,struct node *, struct node *,
		          double *,double *,double *,int *,double,int ,int, int *, 
		          double *, int *,double *);
    void ivoitj_3d       (struct node *,struct node *, struct node *,
		          double *,double *,double *,int *,double,int ,int, int *, 
		          double *,int *,double *);
    void histog          (int,double *,double,double,int *,int);
    void orie2d          (int *,int,int,int *,double *,double *,int,int,int,int *);
    void oriene_2d       (int*, int*, int, int*, int*, int*, int*, int);
    void oriene_3d       (int*, int*, int, int*, int*, int*, int*, int);
    void persym3d        (double[4][4],int,int,int,int,int*,double*,double*,int,int,int*,
		          double*,double*,int,int,int*,int*);
    void quel_angle      (int,int,double ,double,double,double,double,double,double,double,int*,int*);
    void quel_angle_hide (int,int,double ,double,double,double,double,double,double,double);
    int  quel_fils_3d    (double , double , double, struct child *, double , double , double);
    int  quel_fils_2d    (double , double , struct child *, double , double);
    int racines_2d      (double ,double,double,double,
        	          double,double,double,double,int);
    int racines_3d      (double,double,double,
		          double,double,double,double,double,double,
	  	          double,double,double,double,double,double,int);
    int ray_inter_seg    (struct node *,struct node * ,int,double *,double *,
		          int,int,int *,double *,int *);
    int ray_inter_triangle(struct node *,struct node * ,int,double *,double *,
		          int,int,int *,double *,int *);
    void resoud3          (double,double,double,double,double,double,double,double,double,
	                   double *,double *,double *);
    void rorien_2d       (int,int,int,int*,int*,int*,int,int*,int ) ;
    void rorien_3d       ( int,int,int,int,int*,int*,int*,int,int*,int ) ;
    void segfdf          (struct node* ,double,double*,int*,double*,double*,
		          int*,int*,int,int,int*,double*,int*,double*,int*,int);
    void segfdfaxi       (int,int,int,double*,double*,int,int,int*,double*,double*);
    int  seg_cubex       (double,double,double,double,double,double,double,double,double);
    int  seg_cubey       (double,double,double,double,double,double,double,double,double);
    int  seg_cubez       (double,double,double,double,double,double,double,double,double);
    int  seg_in_rectan   (double,double,double,double,
		          double,double,double,double);
    int  seg_rectanx     (double,double,double,double,double,double);
    int  seg_rectany     (double,double,double,double,double,double);
    void soutri          (double,double,double,double,double,double,double,double,double,
                          double,double,double,int *);
    void surface_anneau  (int,int,int,int*,double*,double*);
    void surface_seg     (int,int,int*,double*,double*);
    void surface_tria    (int,int,int*,double*,double*);
    void sym2d           (double[3][3],int,int,int,int,int*,double*,double*,int,int,int*,
	                  double*,double*,int,int,int*,int*);
    void sym3d           (double[4][4],int,int,int,int,int*,double*,double*,int,int,int*,
	                  double*,double*,int,int,int*,int*);
    void tab_integ       (int,int);
    void triafdf         (struct node* ,double,double*,int*,
                          double*,double*,double*,double*,double*,double*,
		          int*,int*,int,int,int*,double*,int*,double*,int*,int);
    int  tria_in_cube    (double,double,double,double,double,double,
		          double,double,double,double,double,double,
		          double,double,double);
    void triface         (struct element *,struct element *,int*,
                          int,int, int *,double *,
                          double,double,double,double,double,double);
    void triseg          (struct element *,struct element *,int*,int,int, int *,double *,
		          double,double,double,double);
    void tuer_tree       (struct node *,int);
    void verif_coor_3d   (int,int,int,int *,double *,int ,double *,
		          int ,double *,int,double);
    void veri_fbor_3d    (int,int,int, int *, int *);
    void veri_nbor_3d    (int,int,int,int*,int*,int*, int *,int);
    void veri_per_3d     (int,int,int,int*,double*,int,double*); 
    void veri_sym_3d     (int,int,int,int *,double *,int,double *,int,double);
    void voisic_2d       (int*, int*, int, int, int) ;
    void voisic_3d       (int*, int*, int, int, int) ;
    void voxel_voisin_2d (double *,double *,double,double, double,double,
		          double*,double*,double *,double);
    void voxel_voisin_3d (double *,double *,double *,double,double,double,
		          double,double,double, double*,double*,double *,double);



/* Fonctions C appellees depuis des sous-programmes Fortran */

void   proc (soutri, SOUTRI) (double, double, double, double,
			      double, double, double, double,
     			      double, double, double, double, int *);

